

function f1=pca(comp_no)

im_val={'text11.gif','text12.gif','text21.gif','text22.gif','text31.gif','text32.gif','text41.gif','text42.gif','text51.gif','text52.gif','text61.gif','text62.gif'}

im_po=numel(im_val);

dat=double(imread('text11.gif'));
stack=cat(3,dat);

for x=2:im_po
   dat=double(imread(char(im_val(x))));
   stack=cat(3,stack,dat);
end

[vect,coord]=imstack2vectors(stack);

PRICO=princomp(vect,11);
f1=PRICO.ems;

PCmat=PRICO.A;
edist=[];

for i=1:im_po
    for j=1:im_po
        edist(i,j) = norm(PCmat(:,i)-PCmat(:,j));
    end
end

disp('   EUCLIDEAN DISTANCE');
disp(edist);

cosdist=[];

for i=1:im_po
    for j=1:im_po
        cosdist(i,j) =1-(dot(PCmat(:,i),PCmat(:,j)))/(norm(PCmat(:,i))*norm(PCmat(:,j)));
    end
end

disp('    COSINE DISTANCE ');
disp(cosdist);

for j=1:12
    h1=PRICO.X(:,j);
    h1=reshape(h1,100,100);
    figure;
    imshow(h1,[]);    
end

recvect=PRICO.X;
edist1=[];

for i=1:im_po
    for j=1:im_po
        edist1(i,j) = norm(vect(:,i)-recvect(:,j));
    end
end

disp('   EUCLIDEAN DISTANCE BETWEEN ORIGNAL AND PCA IMAGES');
disp(edist1);

cosdist1=[];

for i=1:im_po
    for j=1:im_po
        cosdist1(i,j) =1-(dot(vect(:,i),recvect(:,j)))/(norm(vect(:,i))*norm(recvect(:,j)));
    end
end

disp('   COSINE DISTANCE BETWEEN ORIGNAL AND PCA IMAGES');
disp(cosdist1);

return;
